<template>
  <el-drawer
    v-model="drawerEnabled"
    modal-class="game-drawer"
    :lock-scroll="false"
    :title="game.GameProviderDisplayName"
    direction="btt"
  >
    <div
      class="flex justify-between items-center w-full font-semibold leading-[20px] text-[var(--title-font-color)]"
    ></div>
    <div class="w-full flex flex-col mb-auto">
      <div class="text-xs leading-[18px] text-[var(--title-font-color)] mb-2">
        {{ game.GameName }}
      </div>
      <div class="flex h-auto mb-2">
        <span v-if="game.IsHotGame" class="game__badge box-shadow-inset">
          {{ $t("hot") }}
        </span>
        <span v-if="game.IsNewGame && !game.IsHotGame" class="game__badge box-shadow-inset">
          {{ $t("new") }}
        </span>
      </div>
    </div>
    <div
      class="flex justify-between items-center w-full"
      @click="handleGameClicked(game.GameId)"
    >
      <el-button class="">{{ $t("play_now") }}</el-button>
    </div>
  </el-drawer>
</template>

<script lang="ts">
import { IGameBsi } from "@/models/bsiGameList";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import { store } from "@/store";

export default defineComponent({
  props: {
    game: {
      type: Object as PropType<IGameBsi>,
      required: true,
    },
    drawer: {
      type: Boolean,
      required: true,
    },
  },
  setup(props) {
    const { drawer } = toRefs(props);
    const router = useRouter();
    const authenticated = computed(() => store.state.auth);
    const handleGameEntryOpenWindow = (
      gameId: number,
      width: number,
      height: number,
      entranceLocation = EnumEntranceLocation.Other
    ) => {
      const position = reactive({
        x: screen.width / 2 - width / 2,

        y: screen.height / 2 - height / 2,
      });
      window.open(
        `/game/${gameId}?location=${entranceLocation}&pop`,
        "popupWindow",
        `width=${width},height=${height},left=${position.x},top=${position.y}`
      );
    };
    const handleGameClicked = (gameId: number) => {
      if (authenticated.value) {
        handleGameEntryOpenWindow(gameId, 550, 850);
      } else {
        router.push("/login");
      }
    };
    return {
      drawerEnabled: drawer,
      handleGameClicked,
      authenticated,
    };
  },
});
</script>

<style lang="scss" scoped>
.selected {
  color: var(--hint) !important;
}
:deep(.el-input__inner) {
  background-color: rgb(31, 33, 65);
  height: 48px !important;
  border-radius: 8px;
}
.text-primary {
  color: var(--primary);
}
:deep(button.el-button) {
  border: none;
  box-shadow: var(--box-shadow);
  text-transform: uppercase;
  box-sizing: border-box;
  color: #fff;
  background: var(--primary);
  border: 2px solid var(--element-border-color);
  width: 100%;
  max-width: 348px;
  height: 40px;
  border-radius: 6px;
}
:deep(.el-button span) {
  @apply text-sm font-bold leading-4;
}
:deep(.el-input__suffix) {
  @apply flex items-center;
}
:deep(.game__badge) {
  @apply py-1 px-[10px] min-w-[52px] mr-[6px] text-center text-xs leading-[1.5] font-semibold text-[#707585] rounded-[20px] capitalize;
  background-color: var(--button-bg);
}
</style>
